@echo off

goto filter

:	The build.bat file generates the GTAP5 dataset 
:	(gtap001.gdx) from the GTAP5 dataset.
:
:	The GTAP data (gsddat.har) needs to be placed in ..\data\
:
:	For more information, see readme.txt in this archive or
:	http://debreu.colorado.edu/gtap/gtapgams.html
:
:	Thomas Rutherford and Sergey Paltsev
:	rutherford@colorado.edu
:	May 2001

:if exist ..\data\gtap001.gdx goto message
:if exist ..\data\gtap.gdx goto filter
if exist ..\data\gsddat.har goto start

echo	Error: cannot find ..\data\gsddat.har
echo.
echo	You need to contact GTAP to obtain this file.
echo.
echo	For more information see README.TXT
echo.
goto end

:start
echo	Convert gsddat.har into ..\data\gsddat.gdx
har2gdx ..\data\gsddat.har ..\data\gsddat.gdx
har2gdx ..\data\gsdvole.har ..\data\gsdvole.gdx

pause
echo	Use GAMS to relabel, scale, and create ..\data\gtap.gdx:
echo.
pause
call gams relabel

:filter
echo	Use GAMS to filter, recalibrate, and create gtap001.gdx:
echo.
echo	$setglobal tolerance 001  >filter.inc
pause
call gams filter

echo	The GTAPinGAMS dataset is in ..\data\gtap001.gdx
echo.	
pause

:aggr
echo	Will now aggregate the ..\data\gtap001.gdx to produce ..\data\gtap5_small.gdx
echo.	
pause
gams gtapaggr --ds=gtap5_small

:model
echo	Will now run an illustrative MPSGE model 
echo.	
pause
cd ..
cd models
call gams mrtmge
cd..
cd build
goto end

:message
echo.
echo	You already have the GTAPinGAMS dataset.
echo.	
echo	If you want to rebuild it, delete the file GTAP001.GDX
echo	from the DATA subdirectory, and run BUILD.BAT again.
echo.

:end
