$STITLE  GTAPinGAMS -- Simple GDP Report for a Multiregional Dataset

parameter       sector          Economic activity by sector,
                region          Economic activity by region,
                order           row order for sorting;

sector(i,"gdp") = sum((f,r), pf0(f,i,r)*vfm(f,i,r));
sector(i,"gdp%") = 100 * sector(i,"gdp") / sum(j, sector(j,"gdp"));

region(r,"gdp") = sum((i,f), pf0(f,i,r)*vfm(f,i,r));
region(r,"gdp%") = 100 * region(r,"gdp") / sum(s, region(s,"gdp"));

sector(i,"trade") = sum((r,s), pmx0(i,r,s)*vxmd(i,r,s)+pmt0(i,r,s)*vtwr(i,r,s));
sector(i,"trade%") = 100 * sector(i,"trade") / sum(j, sector(j,"trade"));

region(r,"trade") = sum((i,s), pmx0(i,r,s)*vxmd(i,r,s)+pmt0(i,r,s)*vtwr(i,r,s));
region(r,"trade%") = 100 * region(r,"trade") / sum(s, region(s,"trade"));

display sector, region;

*       Generate a formatted report as well:

$set filename gdpreport
$if setglobal dataset $set filename %dataset%
$if setglobal target  $set filename %target%
file gdprep /%filename%.ech/; put gdprep; gdprep.nd=1;

*       Generate a sorted report:

$setglobal row_order order

order(i) = sector(i,"trade");
$batinclude gams2tbl sector
order(i) = 0;

order(r) = region(r,"trade");
$batinclude gams2tbl region
order(r) = 0;
putclose;

*       Put out some summary statistics on the screen:

file kcon /con/; put kcon //; kcon.nd = 1;

order(i) = sector(i,"trade");
$batinclude gams2tbl sector
order(i) = 0;

order(r) = region(r,"trade");
$batinclude gams2tbl region
order(r) = 0;

put //"Summary tables written to %filename%.ech."/;
