$title gtapsets  Retrieves GTAP source sets and writes them with appropriate names

*	Dataset is defined on the command line:

*       Read the mapping file to find the name of the source dataset:

$include ..\defines\%dataset%.map

*       Verify that the source has been declared:

$if not setglobal source $abort "Did not find $setglobal source in %dataset%.map.";


*       See that the source set and dat files are there:

$if not exist ..\defines\%source%.set $abort "Did not find ..\defines\%source%.set.";
$if not exist ..\data\%source%.gdx $abort "Did not find ..\data\%source%.gdx.";

*       Read the source sets:

$include ..\defines\%source%.set

*       Write these out with revised names:

file kset /gtapaggr.set/; kset.lw=0; put kset;
put 'set ii /'/; loop(i, put i.tl/;); put '/;'/;
put 'set rr /'/; loop(r, put r.tl/;); put '/;'/;
putclose;
