$TITLE  Program for Scaling and Relabeling a GTAP Dataset

$setglobal source gsddat
$setglobal dataset gtap
$if exist relabel.inc $include relabel.inc

$onempty

*       Read the model sets:

SET   R	  Regions /
	AUS 	Australia
	NZL 	New Zealand
	CHN 	China
	HKG 	Hong Kong
	JPN 	Japan
	KOR 	Korea
	TWN 	Taiwan
	IDN 	Indonesia
	MYS 	Malaysia
	PHL 	Philippines
	SGP 	Singapore
	THA 	Thailand
	VNM 	Vietnam
	BGD 	Bangladesh
	IND 	India
	LKA 	Sri Lanka
	XSA 	Rest of South Asia
	CAN 	Canada
	USA 	United States
	MEX 	Mexico
	XCM 	Central America and the Caribbean
	COL 	Colombia
	PER 	Peru
	VEN 	Venezuela
	XAP 	Rest of Andean Pact
	ARG 	Argentina
	BRA 	Brazil
	CHL 	Chile
	URY 	Uruguay
	XSM 	Rest of South America
	AUT 	Austria
	BEL 	Belgium
	DNK 	Denmark
	FIN 	Finland
	FRA 	France
	DEU 	Germany
	GBR 	United Kingdom
	GRC 	Greece
	IRL 	Ireland
	ITA 	Italy
	LUX 	Luxembourg
	NLD 	Netherlands
	PRT 	Portugal
	ESP 	Spain
	SWE 	Sweden
	CHE 	Switzerland
	XEF 	Rest of EFTA
	ALB 	Albania
	BGR 	Bulgaria
	HRV 	Croatia
	CZE 	Czech Republic
	HUN 	Hungary
	MLT 	Malta
	POL 	Poland
	ROM 	Romania
	SVK 	Slovakia
	SVN 	Slovenia
	EST 	Estonia
	LVA 	Latvia
	LTU 	Lithuania
	RUS 	Russian Federation
	XSU 	Rest of Former Soviet Union
	CYP 	Cyprus
	TUR 	Turkey
	XME 	Rest of Middle East
	MAR 	Morocco
	XNF 	Rest of North Africa
	BWA 	Botswana
	XSC 	Rest of South African Customs Union
	MWI 	Malawi
	MOZ 	Mozambique
	TZA 	Tanzania
	ZMB 	Zambia
	ZWE 	Zimbabwe
	XSF 	Other Southern Africa
	UGA 	Uganda
	XSS 	Rest of Sub Saharan Africa
	XRW 	Rest of World /;


SET   I	  Sectors /
	PDR "Paddy rice",
	WHT "Wheat",
	GRO "Cereal grains nec",
	V_F "Vegetables, fruit, nuts",
	OSD "Oil seeds",
	C_B "Sugar cane, sugar beet",
	PFB "Plant-based fibers",
	OCR "Crops nec",
	CTL "Bovine cattle, sheep and goats, horses",
	OAP "Animal products nec",
	RMK "Raw milk",
	WOL "Wool, silk-worm cocoons",
	FRS "Forestry",
	FSH "Fishing",
	COL "Coal",
	OIL "Oil",
	GAS "Gas",
	OMN "Minerals nec",
	CMT "Bovine meat products",
	OMT "Meat products nec",
	VOL "Vegetable oils and fats",
	MIL "Dairy products",
	PCR "Processed rice",
	SGR "Sugar",
	OFD "Food products nec",
	B_T "Beverages and tobacco products",
	TEX "Textiles",
	WAP "Wearing apparel",
	LEA "Leather products",
	LUM "Wood products",
	PPP "Paper products, publishing",
	P_C "Petroleum, coal products",
	CRP "Chemical, rubber, plastic products",
	NMM "Mineral products nec",
	I_S "Ferrous metals",
	NFM "Metals nec",
	FMP "Metal products",
	MVH "Motor vehicles and parts",
	OTN "Transport equipment nec",
	ELE "Electronic equipment",
	OME "Machinery and equipment nec",
	OMF "Manufactures nec",
	ELY "Electricity",
	GDT "Gas manufacture, distribution",
	WTR "Water",
	CNS "Construction",
	TRD "Trade",
	OTP "Transport nec",
	WTP "Water transport",
	ATP "Air transport",
	CMN "Communication",
	OFI "Financial services nec",
	ISR "Insurance",
	OBS "Business services nec",
	ROS "Recreational and other services",
	OSG "Public Administration, Defense, Education, Health",
	DWE "Dwellings" 
	CGD Savings good (

	"FOR"   Forestry (GTAP syntax),
	CGDS	Savings good (GTAP syntax)/;	

SET	DROP(I) /
	"FOR"	Forestry (GTAP syntax),
	CGDS	Savings good (GTAP syntax)/;

SET   F	  Factors of production /
	LND	Land,
	SKL	Skilled labor,
	LAB	Unskilled labor,
	CAP	Capital,
	RES	Natural resources

	Capital,
	SkLab,
	Land,
	UnSkLab,
	NatlRes/;

SET IORIG(I) Sectoral and commodity aggregation in GEMPACK /
	PDR paddy rice
	WHT wheat
	GRO cereal grains nec
	V_F vegetables fruit nuts
	OSD oil seeds
	C_B sugar cane sugar beet
	PFB plant-based fibers
	OCR crops nec
	CTL bo horses
	OAP animal products nec
	RMK raw milk
	WOL wool silk-worm cocoons
	"FOR" forestry
	FSH fishing
	COL coal
	OIL oil
	GAS gas
	OMN minerals nec
	CMT bo meat products
	OMT meat products
	VOL vegetable oils and fats
	MIL dairy products
	PCR processed rice
	SGR sugar
	OFD food products nec
	B_T beverages and tobacco products
	TEX textiles
	WAP wearing apparel
	LEA leather products
	LUM wood products
	PPP paper products publishing
	P_C petroleum coal products
	CRP chemical rubber plastic products
	NMM mineral products nec
	I_S ferrous metals
	NFM metals nec
	FMP metal products
	MVH motor vehicles and parts
	OTN transport equipment nec
	ELE electronic equipment
	OME machinery and equipment nec
	OMF manufactures nec
	ELY electricity
	GDT gas manufacture distribution
	WTR water
	CNS construction
	TRD trade
	OTP transport nec
	WTP water transport
	ATP air transport
	CMN communication
	OFI financial services nec
	ISR insurance
	OBS business services nec
	ROS recreational and other services
	OSG public admin and defence education health
	DWE ownership of dwellings

	CGDS	Savings good/;

SET FORIG(F) /	Capital,
		SkLab,
		Land,
		UnSkLab,
		NatlRes/;

SET	DIR  Input source /domestic, imported/;

SET	MAPI(*,I) /
	PDR.PDR,WHT.WHT,GRO.GRO,V_F.V_F,OSD.OSD,C_B.C_B,PFB.PFB,OCR.OCR,
	CTL.CTL,OAP.OAP,RMK.RMK,WOL.WOL,"FOR".FRS,FSH.FSH,COL.COL,OIL.OIL,GAS.GAS,
	OMN.OMN,CMT.CMT,OMT.OMT,VOL.VOL,MIL.MIL,PCR.PCR,SGR.SGR,OFD.OFD,B_T.B_T,
	TEX.TEX,WAP.WAP,LEA.LEA,LUM.LUM,PPP.PPP,P_C.P_C,CRP.CRP,NMM.NMM,I_S.I_S,
	NFM.NFM,FMP.FMP,MVH.MVH,OTN.OTN,ELE.ELE,OME.OME,OMF.OMF,ELY.ELY,GDT.GDT,
	WTR.WTR,CNS.CNS,TRD.TRD,OTP.OTP,WTP.WTP,ATP.ATP,CMN.CMN,OFI.OFI,ISR.ISR
	OBS.OBS,ROS.ROS,OSG.OSG,DWE.DWE,CGDS.CGD/,

	MAPF(FORIG,F) / LAND.LND,CAPITAL.CAP,SKLAB.SKL,UNSKLAB.LAB,NatlRes.RES/;

ALIAS (IORIG,JORIG);

ALIAS (F,FF), (R,S,RR,SS), (I,J,II,JJ);

PARAMETER
        ADRV(IORIG,R,S)		VALUE OF ANTI-DUMPING DUTY
        TFRV(IORIG,R,S)         VALUE OF ORDINARY DUTIES
        VRRV(IORIG,R,S)		VALUE OF VERs
        XTRV(IORIG,R,S)		VALUE OF ORDINARY EXPORT SUBSIDIES OR TAXES
        PURV(IORIG,R,S)		VALUE OF PRICE UNDERTAKINGS
        MFRV(IORIG,R,S)		VALUE OF MFA RENTS

        SAVE(R )                SAVINGS
        VDEP(R )                DEPRECIATION

        VKB(R )                 VALUE OF CAPITAL STOCK (BEGINNING OF PERIOD)
        VST(I, R )              VALUE OF INTERNATIONAL TRANSPORT SALES


        VXMD(I, R, S )          VALUE OF COMMODITY TRADE (FOB - NET EXPORT TAX)


        MTAX(I, R, S)           VALUE OF IMPORT TARIFFS
        XTAX(I, R, S)           VALUE OF EXPORT TAXES

        EVOA(F, R )             VALUE OF FACTOR SUPPLY (NET OF TAX)

        EVFA(F, I, R)           VALUE OF FACTOR INPUTS (GROSS OF TAX)
	TVOM(I,R)		Sales of domestic product at market prices
        VFM(F, I, R )           VALUE OF FACTOR INPUTS (NET OF TAX)

        VDM(I,R)                VALUE OF DOMESTIC SALES
        VAFM(J,I,R)             AGGREGATE INTERMEDIATE INPUTS

	VDFM(I,J,R)		Domestic intermediate
	VIFM(I,J,R)		Imported intermediate
	VDFA(I,J,R)		Domestic intermediate (gross of tax)
	VIFA(I,J,R)		Imported intermediate (gross of tax)
	VDGM(I,R)		Domestic public demand
	OSEP(I,R)		Ordinary output subsidy,
	ISEP(I,I,R,DIR)		Intermediate input subsidies,
	VDGA(I,R)		Domestic public demand (gross of tax)
	VIGM(I,R)		Import public demand
	VIGA(I,R)		Import public demand (gross of tax)
	VIPM(I,R)		Imported final demand
	VIPA(I,R)		Imported final demand (gross of tax)
	VDPM(I,R)		Domestic final demand
	VDPA(I,R)		Domestic final demand (gross of tax)

	VXWD(I,R,S)		Trade flow at world prices (net transport cost)
	VIWS(I,R,S)		Trade flows at world prices (gross transport cost)
	VIMS(I,R,S)		Trade flows gross transport and tariff

        VTI(J,I,R)              INTERMEDIATE INPUT TAX
        VGM(I,R)		VALUE OF GOVERNMENT INPUTS
        VTG(I,R)                VALUE OF TAX ON GOVERNMENT DEMAND
        VPM(I,R)                AGGREGATE PRIVATE DEMANDS
        VTP(I,R)                VALUE OF TAX ON PRIVATE DEMAND
        VTWR1(I, R, S)           VALUE OF TRANSPORT SERVICES (imputed)
        VTWR(J, I, R, S)           VALUE OF TRANSPORT SERVICES


        ADREV(I,R,S)            VALUE OF ANTI-DUMPING DUTY
        TARIFREV(I,R,S)         VALUE OF ORDINARY DUTIES
        VERREV(I,R,S)           VALUE OF VERs
        XTREV(I,R,S)            VALUE OF ORDINARY EXPORT SUBSIDIES OR TAXES
        PUREV(I,R,S)            VALUE OF PRICE UNDERTAKINGS
        MFAREV(I,R,S)           VALUE OF MFA RENTS,
	FBEPF(F,I,R)		FACTOR-BASED SUBSIDIES,
	DPSM(R)			SUM OF DISTRIBUTION PARAMETERS IN HOUSEHOLD DEMAND SYSTEM

	EVF(I,J,R)		Volume of energy inputs by firms (MTOE)
	EVH(I,R)		Volume of energy inputs by households (MTOE)
	EVT(I,R,S)		Volume of energy trade (MTOE);

$gdxin '..\data\gsddat.gdx'
$load
$load EVFA EVOA SAVE VIFA VDFA VIPA VDPA VIGA VDGA TVOM VFM VIFM VDFM VIPM VDPM VIGM VDGM OSEP ISEP
$load FBEPF DPSM VDEP VIMS VIWS VKB VST VXMD VXWD
$load ADRV=ADREV MFRV=MFAREV PURV=PUREV TFRV=TARIFREV VRRV=VERREV VTWR=VTWRINI XTRV=XTREV

$gdxin '..\data\gsdvole.gdx'
$load
$load evf evh evt

EVF(IORIG,JORIG,R) = round(EVF(IORIG,JORIG,R), 6);
EVH(IORIG,R) = round(EVH(IORIG,R), 6);
EVT(IORIG,R,S) = round(EVT(IORIG,R,S), 6);

EVOA(FORIG, R ) = round(EVOA(FORIG,R), 6);
TFRV(IORIG,R,S) = round(TFRV(IORIG,R,S), 6);
ADRV(IORIG,R,S) = round(ADRV(IORIG,R,S), 6);
MFRV(IORIG,R,S) = round(MFRV(IORIG,R,S), 6);
VRRV(IORIG,R,S) = round(VRRV(IORIG,R,S), 6);
XTRV(IORIG,R,S) = round(XTRV(IORIG,R,S), 6);
PURV(IORIG,R,S) = round(PURV(IORIG,R,S), 6);
VST( IORIG, R ) = round(VST( IORIG, R ), 6);
VIGA(IORIG,R) = round(VIGA(IORIG,R), 6);
VDGA(IORIG,R) = round(VDGA(IORIG,R), 6);
VIGM(IORIG,R) = round(VIGM(IORIG,R), 6);
VDGM(IORIG,R) = round(VDGM(IORIG,R), 6);
VDPA(IORIG,R) = round(VDPA(IORIG,R), 6);
VIPA(IORIG,R) = round(VIPA(IORIG,R), 6);
VDPM(IORIG,R) = round(VDPM(IORIG,R), 6);
VIPM(IORIG,R) = round(VIPM(IORIG,R), 6);
VXWD(IORIG,R,S) = round(VXWD(IORIG,R,S), 6);
VIWS(IORIG,R,S) = round(VIWS(IORIG,R,S), 6);
VIMS(IORIG,R,S) = round(VIMS(IORIG,R,S), 6);
VXMD(IORIG, R, S ) = round(VXMD(IORIG, R, S ), 6);
EVFA(FORIG, IORIG, R) = round(EVFA(FORIG, IORIG, R), 6);
VFM( FORIG, IORIG, R ) = round(VFM( FORIG, IORIG, R ), 6);
VDFM(IORIG,JORIG,R) = round(VDFM(IORIG,JORIG,R), 6);
VIFM(JORIG,IORIG,R) = round(VIFM(JORIG,IORIG,R), 6);
VDFA(IORIG,JORIG,R) = round(VDFA(IORIG,JORIG,R), 6);
VIFA(IORIG,JORIG,R) = round(VIFA(IORIG,JORIG,R), 6);
VTWR(IORIG,JORIG,R,S) = round(VTWR(IORIG,JORIG,R,S), 6);

LOOP(MAPF(FORIG,F),
	EVOA(F, R )     = EVOA(FORIG, R )   ;
);
LOOP(MAPI(IORIG,I),
	TARIFREV(I,R,S) = TFRV(IORIG,R,S) ;
	ADREV(I,R,S) = ADRV(IORIG,R,S)       ;
	MFAREV(I,R,S) = MFRV(IORIG,R,S)     ;
	VERREV(I,R,S) = VRRV(IORIG,R,S)     ;
	XTREV(I,R,S) = XTRV(IORIG,R,S)       ;
	PUREV(I,R,S) = PURV(IORIG,R,S)       ;
	EVT(I,R,S) = EVT(IORIG,R,S);
);
LOOP(MAPI(IORIG,I)$(NOT MAPI(I,I)) ,
	EVH(I,R)	= EVH(IORIG,R);
	VST( I, R )	= VST( IORIG, R )   ;
	VIGA(I,R)	= VIGA(IORIG,R)     ;
	VDGA(I,R)	= VDGA(IORIG,R)     ;
	VIGM(I,R)	= VIGM(IORIG,R)     ;
	VDGM(I,R)	= VDGM(IORIG,R)     ;
	VDPA(I,R)	= VDPA(IORIG,R)     ;
	VIPA(I,R)	= VIPA(IORIG,R)     ;
	VDPM(I,R)	= VDPM(IORIG,R)     ;
	VIPM(I,R)	= VIPM(IORIG,R)     ;
	VXWD(I,R,S)	= VXWD(IORIG,R,S)   ;
	VIWS(I,R,S)	= VIWS(IORIG,R,S)   ;
	VIMS(I,R,S)	= VIMS(IORIG,R,S)   ;
	VXMD(I, R, S )	= VXMD(IORIG, R, S );
);
LOOP((MAPI(IORIG,I),MAPF(FORIG,F)),
	EVFA(F, I, R)	= EVFA(FORIG, IORIG, R) ;
	VFM( F, I, R )	= VFM( FORIG, IORIG, R );
);
LOOP((IORIG,I,JORIG,J)$(MAPI(IORIG,I) AND MAPI(JORIG,J)
			AND ((NOT MAPI(I,I)) OR (NOT MAPI(J,J)))),
	EVF(I,J,R) = EVF(IORIG,JORIG,R);
	VDFM(I,J,R) = VDFM(IORIG,JORIG,R);
	VIFM(J,I,R) = VIFM(JORIG,IORIG,R);
	VDFA(I,J,R) = VDFA(IORIG,JORIG,R);
	VIFA(I,J,R) = VIFA(IORIG,JORIG,R);
	vtwr(i,j,r,s) = vtwr(iorig,jorig,r,s);
);

EVF(I,J,R)$(DROP(I) OR DROP(J)) = 0;
EVH(I,R)$DROP(I) = 0;
EVT(I,R,S)$DROP(I) = 0;
VST( I, R )$DROP(I) = 0;
VIGA(I,R)$DROP(I)	= 0;
VDGA(I,R)$DROP(I)	= 0;
VIGM(I,R)$DROP(I)	= 0;
VDGM(I,R)$DROP(I)	= 0;
VDPA(I,R)$DROP(I)	= 0;
VIPA(I,R)$DROP(I)	= 0;
VDPM(I,R)$DROP(I)	= 0;
VIPM(I,R)$DROP(I)	= 0;
VXWD(I,R,S)$DROP(I)	= 0;
VIWS(I,R,S)$DROP(I)	= 0;
VIMS(I,R,S)$DROP(I)	= 0;
VXMD(I, R, S )$DROP(I)	= 0;
EVFA(F, I, R)$DROP(I)	= 0;
VFM( F, I, R )$DROP(I)	= 0;
VDFM(I,J,R)$(DROP(I) OR DROP(J))	= 0;
VIFM(J,I,R)$(DROP(I) OR DROP(J))	= 0;
VDFA(I,J,R)$(DROP(I) OR DROP(J))	= 0;
VIFA(I,J,R)$(DROP(I) OR DROP(J))	= 0;
VTWR(i,j,r,s)$(drop(i) or drop(j)) = 0;

EVFA(FORIG, I, R)  = 0;
VFM( FORIG, I, R ) = 0;
EVOA(FORIG,R) = 0;

*	Scale the data

SCALAR SCALE /1.0E4/;

VKB( R )        = VKB( R )      / SCALE;
SAVE(R )        = SAVE(R )      / SCALE;
VDEP(R )        = VDEP(R )      / SCALE;
EVOA(F, R )     = EVOA(F, R )   / SCALE;
VST( I, R )     = VST( I, R )   / SCALE;
vtwr(i,j,r,s) = vtwr(i,j,r,s) /scale;

EVFA(F, I, R)   = EVFA(F, I, R) / SCALE;
VFM( F, I, R )  = VFM( F, I, R )/ SCALE;
VXMD(I, R, S )  = VXMD(I, R, S )/ SCALE;
VDFM(I,J,R)     = VDFM(I,J,R)   / SCALE;
VIFM(J,I,R)     = VIFM(J,I,R)   / SCALE;
VDFA(I,J,R)     = VDFA(I,J,R)   / SCALE;
VIFA(I,J,R)     = VIFA(I,J,R)   / SCALE;
VIGA(I,R)       = VIGA(I,R)     / SCALE;
VDGA(I,R)       = VDGA(I,R)     / SCALE;
VIGM(I,R)       = VIGM(I,R)     / SCALE;
VDGM(I,R)       = VDGM(I,R)     / SCALE;
VDPA(I,R)       = VDPA(I,R)     / SCALE;
VIPA(I,R)       = VIPA(I,R)     / SCALE;
VDPM(I,R)       = VDPM(I,R)     / SCALE;
VIPM(I,R)       = VIPM(I,R)     / SCALE;
VXWD(I,R,S)     = VXWD(I,R,S)   / SCALE;
VIWS(I,R,S)     = VIWS(I,R,S)   / SCALE;
VIMS(I,R,S)     = VIMS(I,R,S)   / SCALE;

TARIFREV(I,R,S) = TARIFREV(I,R,S) / SCALE;
ADREV(I,R,S) = ADREV(I,R,S)       / SCALE;
MFAREV(I,R,S) = MFAREV(I,R,S)     / SCALE;
VERREV(I,R,S) = VERREV(I,R,S)     / SCALE;
XTREV(I,R,S) = XTREV(I,R,S)       / SCALE;
PUREV(I,R,S) = PUREV(I,R,S)       / SCALE;


*--------------------------------------------------------------------------
*       IMPUTED PARAMETERS:

PARAMETER

EXPEND(R)               REGIONAL EXPENDITURE (PRIVATE PUBLIC AND SAVINGS)
ETAX(F,J,S)             VALUE OF TAXES ON FACTOR INPUTS TO PRODUCTION
INCOME(R)               REGIONAL INCOME FROM FACTORS AND TAXES
YTAX(I,R)               VALUE OF TAXES ON PRODUCTION OUTPUTS
INVEST(R)               REGIONAL INVESTMENT
VGA(I,S)                COMBINED VALUE OF GOVERNMENT PURCHASE (GROSS TAXES)
VIM(I,S)                TOTAL VALUE OF IMPORTS (GROSS TARIFF)
VKE(R)                  VALUE OF END OF PERIOD CAPITAL
VOA(J,S)                VALUE OF OUTPUT AT INPUT COST
VOM(I,R)                VALUE OF OUTPUT (GROSS EXCISE TAX)
VXM(I,R)                VALUE OF EXPORT (NET EXCISE TAX)
VPA(I,S)                COMBINED VALUE OF HOUSEHOLD PURCHASES (GROSS TAXES)
NETAXES(R)              NET TAX REVENUE,
TAXREV(R,*)             TAX REVENUE AND SUBSIDY PAYMENT BY CATEGORY,
BOP(*)                  BALANCE OF PAYMENTS CHK,
TX(I,S,R)               EXPORT TAX RATE (DEFINED ON A NET BASIS)
TM(I,S,R)               IMPORT TARIFF RATE
PMX0(I,S,R)             REFERENCE PRICE OF IMPORTS
PMT0(I,S,R)             REFERENCE PRICE OF TRANSPORT SERVICES
TG(I,R)                 TAX RATES ON GOVERNMENT DEMAND
PG0(I,R)                REFERENCE PRICE OF GOVERNMENT DEMAND
TP(I,R)                 TAX RATE ON PRIVATE DEMAND
PP0(I,R)                REFERENCE PRICE FOR PRIVATE DEMAND
PAI0(J,I,R)             REFERENCE PRICE FOR INTERMEDIATE INPUTS
TF(F,I,R)               FACTOR TAX RATE
PF0(F,I,R)              REFERENCE PRICE FOR FACTOR INPUTS
TY(I,R)                 OUTPUT TAX RATE
TI(J,I,R)               INTERMEDIATE INPUT TAX RATE
VAM(I,R)                AGGREGATE ARMINGTON SUPPLY
VA_SUM(R)               TOTAL FACTOR INCOME NET OF TAX,

*--------------------------------------------------------------------------
*       CROSS-CHECKS:

VTCHK           SUPPLY-DEMAND BALANCE FOR TRANSPORT SERVICES
VIMCHK(I,S)     IMPORT CHECK
INVCHK          INVESTMENT-SAVINGS CHECK
WALRASCHK(R)    INCOME-EXPENDITURE CHECK,
PROFIT(R)       ZERO PROFIT CHK,
CAPFLOW(*)      BENCHMARK CAPITAL FLOWS
VIMPTAX         TOTAL VALUE TAXES ON IMPORTS (LEVIED BY EXPORTING COUNTRY);

SET     IT(I)           TRADED GOODS,
        CGD(I)           CAPITAL GOODS;

CGD("CGD") = YES; IT(I) = YES;  IT(CGD) = NO;

*       ASSIGN IMPUTED VALUES:

VDM(I,R) = VDPM(I,R) + VDGM(I,R) + SUM(J, VDFM(I,J,R));
VAFM(J,I,R) = VDFM(J,I,R) + VIFM(J,I,R);
VTI(J,I,R)$VAFM(J,I,R) = VDFA(J,I,R) + VIFA(J,I,R) - VAFM(J,I,R);
VGM(I,R) = VIGM(I,R) + VDGM(I,R);
VTG(I,R)$VGM(I,R) = VIGA(I,R) + VDGA(I,R) -  VGM(I,R);
VPM(I,R) = VDPM(I,R) + VIPM(I,R);
VTP(I,R)$VPM(I,R)  = VDPA(I,R) + VIPA(I,R) - VPM(I,R);
XTAX(I,R,S) = VXWD(I,R,S) - VXMD(I,R,S);

* Change assignment for VTWR because in GTAP5 there is VTWR(z,I,R,S)
* where z - margin commodity

parameter vtwr1;

** VTWR(I,R,S) = VIWS(I,R,S) - VXWD(I,R,S);
VTWR1(I,R,S) = VIWS(I,R,S) - VXWD(I,R,S);

* VTWR1(I,R,S) = sum(xx, vtwr(xx,I,R,S));

parameter chkt;

chkt(i,r,s) = vtwr1(i,r,s) - sum(j, vtwr(j,i,r,s));

MTAX(I,R,S) = VIMS(I,R,S) - VIWS(I,R,S);
VIM(I,S) = SUM(R, VXMD(I,R,S) + XTAX(I,R,S) + VTWR1(I,R,S) + MTAX(I,R,S));
VXM(I,R) = SUM(S, VXMD(I,R,S)) + VST(I,R);

VOM(I,R) = VDM(I,R) + VXM(I,R);
VOA(J,S) = SUM(I, VAFM(I,J,S) + VTI(I,J,S)) + SUM(F, EVFA(F,J,S));
VOM(CGD,R) = VOA(CGD,R);
VPA(I,S) = VPM(I,S) + VTP(I,S);
VGA(I,S) = VGM(I,S) + VTG(I,S);
ETAX(F,J,S) = EVFA(F,J,S) - VFM(F,J,S);
YTAX(I,R) = VOM(I,R) - VOA(I,R);

*       Adjust for rounding errors in the subcomponents of trade
*       tax and subsidy:

TARIFREV(I,R,S) = MTAX(I,R,S) - ADREV(I,R,S);
XTREV(I,R,S) = XTAX(I,R,S) - MFAREV(I,R,S) - VERREV(I,R,S) - PUREV(I,R,S);

*       Set all the benchmark tax rates and reference prices:

TF(F,I,R)$VFM(F,I,R) = ETAX(F,I,R) / VFM(F,I,R);
PF0(F,J,S) = 1 + TF(F,J,S);
TG(I,R)$VGM(I,R)     = VTG(I,R) / VGM(I,R);
PG0(I,R) = 1 + TG(I,R);
TP(I,R)$VPM(I,R)     = VTP(I,R) / VPM(I,R);
PP0(I,R) = 1 + TP(I,R);
TX(I,R,S)$VXMD(I,R,S) = XTAX(I,R,S) / VXMD(I,R,S);

** TM(I,S,R)$(VXMD(I,S,R) + XTAX(I,S,R) + VTWR(I,S,R))
**        = MTAX(I,S,R) / (VXMD(I,S,R) + XTAX(I,S,R) + VTWR(I,S,R));

TM(I,S,R)$(VXMD(I,S,R) + XTAX(I,S,R) + VTWR1(I,S,R))
        = MTAX(I,S,R) / (VXMD(I,S,R) + XTAX(I,S,R) + VTWR1(I,S,R));

parameter
        tmrate          import tariff rates (%)
        ownimport       own-region imports;

tmrate(i,s,r) = round(100 * tm(i,s,r));

** tmrate("average",i,r)$sum(s,VXMD(I,S,R) + XTAX(I,S,R) + VTWR(I,S,R))
**         = round(100 * sum(s,MTAX(I,S,R)) / sum(s,VXMD(I,S,R) + XTAX(I,S,R) + VTWR(I,S,R)));

tmrate("average",i,r)$sum(s,VXMD(I,S,R) + XTAX(I,S,R) + VTWR1(I,S,R))
         = round(100 * sum(s,MTAX(I,S,R)) / sum(s,VXMD(I,S,R) + XTAX(I,S,R) + VTWR1(I,S,R)));


option tmrate:0:1:1;
display tmrate;

*	TM(I,S,R) is the tariff rate calculated on the C.I.F. price.  PMT0(I,S,R) is the
*	benchmark user cost of transport services, equal to one plus the benchmark tariff

PMT0(I,S,R) = (1 + TM(I,S,R));

*	PMX0(I,S,R) is the benchmark user cost of imports, computed on the producer supply
*	price in the exporting region, NET of transportation cost.  This is the unit cost
*	gross of the applicable export tax and import tariff, but net of transportation cost.

PMX0(I,S,R) = (1 + TM(I,S,R)) * (1 + TX(I,S,R));

*	Note that the benchmark value of imports of good I from region S in region R
*	is given by:

*		pmx0(i,s,r) * vxmd(i,s,r) + pmt0(i,s,r) * vtwr(i,s,r)

*	That is, it equals the supply price in region s gross of export tax and import tariff
*	plus the transport cost gross of tariff.

TI(J,I,R)$VAFM(J,I,R)  = VTI(J,I,R) / VAFM(J,I,R);
TY(I,R)$VOM(I,R) = YTAX(I,R) / VOM(I,R);
DISPLAY TY;

EXPEND(R) = SUM(I, VPA(I,R) + VGA(I,R)) + SAVE(R);
INVEST(R) = SUM(CGD,VOA(CGD,R));
VKE(R) = VKB(R) + INVEST(R) - VDEP(R);
NETAXES(R) =
            SUM(I, VOM(I,R) - VOA(I,R))
        +   SUM(J, SUM(F, EVFA(F,J,R) - VFM(F,J,R)))
        +   SUM((I,J), VTI(I,J,R))
        +   SUM(I, VTP(I,R))
        +   SUM(I, VTG(I,R))
        +   SUM((I,S), MTAX(I,S,R))
        +   SUM((I,S), XTAX(I,R,S));
DISPLAY NETAXES;

SET TAXES /YTAX, ETAX, VTP, VTG, VTI, XTAX, MTAX/;
TAXREV(R,"YTAX") = SUM(I, YTAX(I,R));
TAXREV(R,"ETAX") = SUM((F,J), ETAX(F,J,R));
TAXREV(R,"VTI")  = SUM((I,J), VTI(I,J,R));
TAXREV(R,"VTP")  = SUM(I, VTP(I,R));
TAXREV(R,"VTG")  = SUM(I, VTG(I,R));
TAXREV(R,"MTAX") = SUM((I,S), MTAX(I,S,R));
TAXREV(R,"XTAX") = SUM((I,S), XTAX(I,R,S));
DISPLAY TAXREV;
NETAXES(R) = SUM(TAXES, TAXREV(R,TAXES));   DISPLAY NETAXES;
INCOME(R) = SUM(F, EVOA(F,R)) - VDEP(R) + NETAXES(R);
DISPLAY INCOME;

*       INTERNATIONAL MARKET FOR TRANSPORTATION SERVICES:

** VTCHK = ROUND(SUM((I,R,S), VTWR(I,R,S)) - SUM((I,R), VST(I,R)));
VTCHK = ROUND(SUM((j,I,R,S), VTWR(j,I,R,S)) - SUM((I,R), VST(I,R)));

DISPLAY VTCHK;


*       IMPORT MARKETS:

VIMCHK(I,R) = ROUND(VIM(I,R)-(VGM(I,R)+VPM(I,R)+SUM(J,VAFM(I,J,R))-VDM(I,R)));
DISPLAY VIMCHK;

*       GLOBAL INVESTMENT-SAVINGS BALANCE:

INVCHK = ROUND(SUM(R, INVEST(R) - VDEP(R) - SAVE(R) ));
DISPLAY INVCHK;

*       INCOME-EXPENDITURE BALANCE:
parameter wchk	INCOME-EXPENDITURE BALANCE;

wchk(R,"value") = round(EXPEND(R) - INCOME(R), 8);
wchk(R,"%") = round(100 * (EXPEND(R) - INCOME(R))/EXPEND(R), 2);
DISPLAY wchk;

PARAMETER SURPLUS(R);
*       Factor income:

SURPLUS(r) =  round( sum(f, EVOA(f,r))  - VDEP(r)

* YTAX(I,R)
 + sum(i, VOM(i,r) - VOA(i,r))

* ETAX(F,J,R)
 + sum(j, sum(f, EVFA(f,j,r) - VFM(f,j,r)))

* VTP
 + sum(i, VIPA(i,r) - VIPM(i,r))
 + sum(i, VDPA(i,r) - VDPM(i,r))

* VTG
 + sum(i, VIGA(i,r) - VIGM(i,r))
 + sum(i, VDGA(i,r) - VDGM(i,r))

* VTI
 + sum(j, sum(i, VIFA(i,j,r) - VIFM(i,j,r)))
 + sum(j, sum(i, VDFA(i,j,r) - VDFM(i,j,r)))

* XTAX
 + sum(i, sum(s, XTAX(i,r,s)))

* MTAX
 + sum(i, sum(s, MTAX(i,s,r)))

* EXPEND
 - sum(i, VPA(i,r) + VGA(i,r)) - SAVE(r) , 5);

DISPLAY SURPLUS;

PARAMETER PROFITS, BOP, CHKTRANS, CHKSAVE, MKTCLDOM, MKTCLTRD;

PROFITS(j,r) = round( VOA(j,r) - sum(i,vdfa(i,j,r) + vifa(i,j,r)) - sum(f, evfa(f,j,r)), 8);
display profits;

** BOP(r) = sum(i, sum(s, VXMD(I,R,S)+XTAX(I,R,S)) + VST(i,r))
**         + sum(CGD, VOA(CGD,r)) - VDEP(r)
**        - sum((I,S), VTWR(I,S,R) + XTAX(I,S,R) + VXMD(I,S,R)) - SAVE(r) ;

BOP(r) = sum(i, sum(s, VXMD(I,R,S)+XTAX(I,R,S))) + sum(I,VST(I,r))
         + sum(CGD, VOA(CGD,r)) - VDEP(r)
        - sum((I,S), VTWR1(I,S,R) + XTAX(I,S,R) + VXMD(I,S,R)) - SAVE(r) ;


BOP("TOTAL") = SUM(R, BOP(R));



** CHKTRANS = sum(i,sum(r, sum(s, VTWR(i,r,s)))) - sum(i,sum(r, VST(i,r))) ;
CHKTRANS = sum(i,sum(r, sum(s, VTWR1(i,r,s)))) - sum(I,sum(r, VST(I,r))) ;

display chktrans;


CHKSAVE  = sum(r, SAVE(r)) - sum(r, sum(CGD, VOA(CGD,r)) - VDEP(r));


** MKTCLDOM(i,s) = sum(r, MTAX(I,R,S)+VTWR(I,R,S)+XTAX(I,R,S)+VXMD(I,R,S))
**               - sum(j, VIFM(i,j,s)) - VIPM(i,s) - VIGM(i,s) ;

MKTCLDOM(i,s) = sum(r, MTAX(I,R,S)+VTWR1(I,R,S)+XTAX(I,R,S)+VXMD(I,R,S))
               - sum(j, VIFM(i,j,s)) - VIPM(i,s) - VIGM(i,s) ;


** MKTCLTRD(i,r)$IT(i) = VOM(i,r) - VDM(i,r) - sum(s, VXMD(i,r,s)) - VST(i,r);

MKTCLTRD(i,r)$IT(i) = VOM(i,r) - VDM(i,r) - sum(s, VXMD(i,r,s)) - sum(s,vtwr1(i,r,s));

BOP(r) = round(BOP(r), 2);

CHKTRANS = round(CHKTRANS, 2);

MKTCLDOM(i,s) = round(MKTCLDOM(i,s), 2);

MKTCLTRD(i,r) = round(MKTCLTRD(i,r), 2);

DISPLAY PROFITS, SURPLUS, BOP, CHKTRANS,
        CHKSAVE, MKTCLDOM, MKTCLTRD;

PARAMETER PCT_SAVE, PCT_MKT;
PCT_SAVE = 100 * CHKSAVE / SUM(R, SAVE(R));


PCT_MKT(I,S)$SUM(R, MTAX(I,R,S)+VTWR1(I,R,S)+XTAX(I,R,S)+VXMD(I,R,S))
  = 100 * MKTCLDOM(I,S) /
        SUM(R, MTAX(I,R,S)+VTWR1(I,R,S)+XTAX(I,R,S)+VXMD(I,R,S));

** PCT_MKT(I,S)$SUM(R, MTAX(I,R,S)+VTWR(I,R,S)+XTAX(I,R,S)+VXMD(I,R,S))
**   = 100 * MKTCLDOM(I,S) /
**        SUM(R, MTAX(I,R,S)+VTWR(I,R,S)+XTAX(I,R,S)+VXMD(I,R,S));


DISPLAY PCT_SAVE, PCT_MKT;

SET     D Classes of demand for which import shares are differentiated /
        G       Public,
        C       Private Consumption,
        I       Intermediate input /;

PARAMETER
        A0(D,I,R)       Aggregate supply
        D0(D,I,R)       Domestic demand
        M0(D,I,R)       Import demand;

D0("G",I,R) = VDGM(I,R);
M0("G",I,R) = VIGM(I,R);
D0("C",I,R) = VDPM(I,R);
M0("C",I,R) = VIPM(I,R);
D0("I",I,R) = SUM(J, VDFM(I,J,R));
M0("I",I,R) = SUM(J, VIFM(I,J,R));
A0(D,I,R) = D0(D,I,R)+M0(D,I,R);


*       Save the data in zip format:

execute_unload '..\data\%dataset%', ty, ti, tf, tx, tm, tg, tp, vafm, vfm, vxmd,
	vtwr1=vtwr, vst, vdgm, vigm, vdpm, vipm, save=vsave, vdep, vkb, evf, evh, evt, i, r, f;
